/*
 * UploadArtGUIView.java
 */

package uploadartgui;

import java.awt.Cursor;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLDecoder;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import java.net.URLEncoder;
import java.util.Calendar;
import java.util.Locale;
import javax.imageio.ImageIO;
import uploadartgui.filtros.Filter;
import uploadartgui.filtros.FilterEngine;
import uploadartgui.filtros.Info;
import uploadartgui.utilidades.FTPEngine;
import uploadartgui.utilidades.ImageEngine;

/**
 * The application's main frame.
 */
public class UploadArtGUIView extends FrameView {

    private ProcessArticleTask task;
    private int countThread = 0;
    private int countThread2 = 0;
    public UploadArtGUIView(SingleFrameApplication app) {
        super(app);
        initComponents();

        /* Iniciar el objeto que mantiene comunicación con Joomla */

        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        progressBar.setVisible(false);

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(true);
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                    progressBar.setVisible(false);
                    progressBar.setValue(0);
                } else if ("message".equals(propertyName)) {
                    String text = (String)(evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer)(evt.getNewValue());
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(false);
                    progressBar.setValue(value);
                }
            }
        });

    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = UploadArtGUIApp.getApplication().getMainFrame();
            aboutBox = new UploadArtGUIAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        UploadArtGUIApp.getApplication().show(aboutBox);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel4 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        userJoomla = new javax.swing.JTextField();
        userFTP = new javax.swing.JTextField();
        passJoomla = new javax.swing.JPasswordField();
        passFTP = new javax.swing.JPasswordField();
        clearCredentials = new javax.swing.JButton();
        jLabel15 = new javax.swing.JLabel();
        urlJoomla = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        dirBaseFTP = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        web_alt_image = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        web_cid = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        web_sid = new javax.swing.JTextField();
        web_np = new javax.swing.JCheckBox();
        web_fp = new javax.swing.JCheckBox();
        web_sin_imagen = new javax.swing.JCheckBox();
        countHilosLbl = new javax.swing.JLabel();
        limpiarbtn = new javax.swing.JButton();
        publishByFilter = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        web_url = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        art_title = new javax.swing.JTextField();
        art_autor = new javax.swing.JTextField();
        art_imagen = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        art_texto = new javax.swing.JTextArea();
        jLabel6 = new javax.swing.JLabel();
        publishByEditor = new javax.swing.JButton();
        art_np = new javax.swing.JCheckBox();
        art_fp = new javax.swing.JCheckBox();
        art_noimagen = new javax.swing.JCheckBox();
        jButton4 = new javax.swing.JButton();
        art_sid = new javax.swing.JTextField();
        art_cid = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        countHilosEditor = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();

        mainPanel.setName("mainPanel"); // NOI18N

        jTabbedPane1.setName("jTabbedPane1"); // NOI18N

        jPanel4.setName("jPanel4"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(uploadartgui.UploadArtGUIApp.class).getContext().getResourceMap(UploadArtGUIView.class);
        jLabel11.setText(resourceMap.getString("jLabel11.text")); // NOI18N
        jLabel11.setName("jLabel11"); // NOI18N

        jLabel12.setText(resourceMap.getString("jLabel12.text")); // NOI18N
        jLabel12.setName("jLabel12"); // NOI18N

        jLabel13.setText(resourceMap.getString("jLabel13.text")); // NOI18N
        jLabel13.setName("jLabel13"); // NOI18N

        jLabel14.setText(resourceMap.getString("jLabel14.text")); // NOI18N
        jLabel14.setName("jLabel14"); // NOI18N

        userJoomla.setText(resourceMap.getString("userJoomla.text")); // NOI18N
        userJoomla.setName("userJoomla"); // NOI18N

        userFTP.setText(resourceMap.getString("userFTP.text")); // NOI18N
        userFTP.setName("userFTP"); // NOI18N

        passJoomla.setText(resourceMap.getString("passJoomla.text")); // NOI18N
        passJoomla.setName("passJoomla"); // NOI18N

        passFTP.setText(resourceMap.getString("passFTP.text")); // NOI18N
        passFTP.setName("passFTP"); // NOI18N

        clearCredentials.setText(resourceMap.getString("clearCredentials.text")); // NOI18N
        clearCredentials.setName("clearCredentials"); // NOI18N
        clearCredentials.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearCredentialsActionPerformed(evt);
            }
        });

        jLabel15.setText(resourceMap.getString("jLabel15.text")); // NOI18N
        jLabel15.setName("jLabel15"); // NOI18N

        urlJoomla.setText(resourceMap.getString("urlJoomla.text")); // NOI18N
        urlJoomla.setName("urlJoomla"); // NOI18N

        jLabel16.setText(resourceMap.getString("jLabel16.text")); // NOI18N
        jLabel16.setName("jLabel16"); // NOI18N

        dirBaseFTP.setEditable(false);
        dirBaseFTP.setText(resourceMap.getString("dirBaseFTP.text")); // NOI18N
        dirBaseFTP.setName("dirBaseFTP"); // NOI18N

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(365, 365, 365)
                        .addComponent(clearCredentials))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel12)
                                    .addComponent(jLabel13)
                                    .addComponent(jLabel14))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(userFTP, javax.swing.GroupLayout.DEFAULT_SIZE, 320, Short.MAX_VALUE)
                                    .addComponent(passFTP)
                                    .addComponent(dirBaseFTP)
                                    .addComponent(passJoomla, javax.swing.GroupLayout.DEFAULT_SIZE, 320, Short.MAX_VALUE)))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                                .addComponent(jLabel11)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(urlJoomla)
                                    .addComponent(userJoomla, javax.swing.GroupLayout.DEFAULT_SIZE, 320, Short.MAX_VALUE)))))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel15))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel16)))
                .addContainerGap(161, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGap(26, 26, 26)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel15)
                    .addComponent(urlJoomla, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(userJoomla, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel12)
                            .addComponent(passJoomla, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel13))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addComponent(userFTP, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(passFTP, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel16)
                    .addComponent(dirBaseFTP, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(clearCredentials)
                .addContainerGap(113, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab(resourceMap.getString("jPanel4.TabConstraints.tabTitle"), jPanel4); // NOI18N

        jPanel3.setName("jPanel3"); // NOI18N

        web_alt_image.setText(resourceMap.getString("web_alt_image.text")); // NOI18N
        web_alt_image.setName("web_alt_image"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jPanel2.setName("jPanel2"); // NOI18N

        web_cid.setText(resourceMap.getString("web_cid.text")); // NOI18N
        web_cid.setName("web_cid"); // NOI18N

        jLabel7.setText(resourceMap.getString("jLabel7.text")); // NOI18N
        jLabel7.setName("jLabel7"); // NOI18N

        jLabel8.setText(resourceMap.getString("jLabel8.text")); // NOI18N
        jLabel8.setName("jLabel8"); // NOI18N

        web_sid.setText(resourceMap.getString("web_sid.text")); // NOI18N
        web_sid.setName("web_sid"); // NOI18N

        web_np.setText(resourceMap.getString("web_np.text")); // NOI18N
        web_np.setName("web_np"); // NOI18N

        web_fp.setText(resourceMap.getString("web_fp.text")); // NOI18N
        web_fp.setName("web_fp"); // NOI18N

        web_sin_imagen.setText(resourceMap.getString("web_sin_imagen.text")); // NOI18N
        web_sin_imagen.setName("web_sin_imagen"); // NOI18N

        countHilosLbl.setText(resourceMap.getString("countHilosLbl.text")); // NOI18N
        countHilosLbl.setName("countHilosLbl"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(uploadartgui.UploadArtGUIApp.class).getContext().getActionMap(UploadArtGUIView.class, this);
        limpiarbtn.setAction(actionMap.get("limpiarForm")); // NOI18N
        limpiarbtn.setText(resourceMap.getString("limpiarbtn.text")); // NOI18N
        limpiarbtn.setName("limpiarbtn"); // NOI18N

        publishByFilter.setAction(actionMap.get("uploadContent")); // NOI18N
        publishByFilter.setText(resourceMap.getString("publishByFilter.text")); // NOI18N
        publishByFilter.setName("publishByFilter"); // NOI18N
        publishByFilter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                publishByFilterActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(web_cid, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(web_sid, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(web_np)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(web_fp)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(web_sin_imagen)
                        .addGap(18, 18, 18)
                        .addComponent(countHilosLbl, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addComponent(limpiarbtn)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(publishByFilter)
                        .addContainerGap())))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(web_cid, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(web_sid, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addComponent(web_fp)
                    .addComponent(web_np)
                    .addComponent(web_sin_imagen)
                    .addComponent(countHilosLbl))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(publishByFilter)
                    .addComponent(limpiarbtn))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        web_url.setText(resourceMap.getString("web_url.text")); // NOI18N
        web_url.setName("web_url"); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(web_alt_image, javax.swing.GroupLayout.DEFAULT_SIZE, 521, Short.MAX_VALUE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGap(50, 50, 50)
                        .addComponent(web_url, javax.swing.GroupLayout.DEFAULT_SIZE, 521, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(web_url, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(web_alt_image, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(184, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab(resourceMap.getString("jPanel3.TabConstraints.tabTitle"), jPanel3); // NOI18N

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel1.border.title"))); // NOI18N
        jPanel1.setName("jPanel1"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        art_title.setText(resourceMap.getString("art_title.text")); // NOI18N
        art_title.setName("art_title"); // NOI18N

        art_autor.setText(resourceMap.getString("art_autor.text")); // NOI18N
        art_autor.setName("art_autor"); // NOI18N

        art_imagen.setText(resourceMap.getString("art_imagen.text")); // NOI18N
        art_imagen.setName("art_imagen"); // NOI18N

        jButton2.setAction(actionMap.get("openBrowserDialog")); // NOI18N
        jButton2.setText(resourceMap.getString("jButton2.text")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        art_texto.setColumns(20);
        art_texto.setRows(5);
        art_texto.setName("art_texto"); // NOI18N
        jScrollPane1.setViewportView(art_texto);

        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N

        publishByEditor.setAction(actionMap.get("uploadContent2")); // NOI18N
        publishByEditor.setText(resourceMap.getString("publishByEditor.text")); // NOI18N
        publishByEditor.setName("publishByEditor"); // NOI18N

        art_np.setText(resourceMap.getString("art_np.text")); // NOI18N
        art_np.setName("art_np"); // NOI18N

        art_fp.setText(resourceMap.getString("art_fp.text")); // NOI18N
        art_fp.setName("art_fp"); // NOI18N

        art_noimagen.setText(resourceMap.getString("art_noimagen.text")); // NOI18N
        art_noimagen.setName("art_noimagen"); // NOI18N

        jButton4.setAction(actionMap.get("cleanFields")); // NOI18N
        jButton4.setText(resourceMap.getString("jButton4.text")); // NOI18N
        jButton4.setName("jButton4"); // NOI18N

        art_sid.setText(resourceMap.getString("art_sid.text")); // NOI18N
        art_sid.setName("art_sid"); // NOI18N

        art_cid.setText(resourceMap.getString("art_cid.text")); // NOI18N
        art_cid.setName("art_cid"); // NOI18N

        jLabel9.setText(resourceMap.getString("jLabel9.text")); // NOI18N
        jLabel9.setName("jLabel9"); // NOI18N

        jLabel10.setText(resourceMap.getString("jLabel10.text")); // NOI18N
        jLabel10.setName("jLabel10"); // NOI18N

        countHilosEditor.setText(resourceMap.getString("countHilosEditor.text")); // NOI18N
        countHilosEditor.setName("countHilosEditor"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 559, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addComponent(publishByEditor)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton4))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4)
                            .addComponent(jLabel5)
                            .addComponent(jLabel3))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(art_title, javax.swing.GroupLayout.DEFAULT_SIZE, 513, Short.MAX_VALUE)
                            .addComponent(art_autor, javax.swing.GroupLayout.DEFAULT_SIZE, 513, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                .addComponent(art_imagen, javax.swing.GroupLayout.DEFAULT_SIZE, 386, Short.MAX_VALUE)
                                .addGap(18, 18, 18)
                                .addComponent(jButton2))))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel6)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(art_np)
                                .addGap(18, 18, 18)
                                .addComponent(art_fp)
                                .addGap(18, 18, 18)
                                .addComponent(art_noimagen)))
                        .addGap(18, 18, 18)
                        .addComponent(countHilosEditor, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 123, Short.MAX_VALUE)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel10)
                                .addGap(7, 7, 7))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel9)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)))
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(art_cid, javax.swing.GroupLayout.DEFAULT_SIZE, 61, Short.MAX_VALUE)
                            .addComponent(art_sid))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(art_title, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(art_autor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(art_imagen, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(art_np)
                    .addComponent(art_fp)
                    .addComponent(art_noimagen)
                    .addComponent(art_cid, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10)
                    .addComponent(countHilosEditor))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(art_sid, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel9))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(publishByEditor)
                    .addComponent(jButton4)))
        );

        jTabbedPane1.addTab(resourceMap.getString("jPanel1.TabConstraints.tabTitle"), jPanel1); // NOI18N

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 596, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 346, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setText(resourceMap.getString("exitMenuItem.text")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setText(resourceMap.getString("aboutMenuItem.text")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 616, Short.MAX_VALUE)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 446, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
    }// </editor-fold>//GEN-END:initComponents

    private void publishByFilterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_publishByFilterActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_publishByFilterActionPerformed

    private void clearCredentialsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearCredentialsActionPerformed
        // TODO add your handling code here:
        userJoomla.setText("");
        passJoomla.setText("");
        userFTP.setText("");
        passFTP.setText("");
    }//GEN-LAST:event_clearCredentialsActionPerformed

    @Action
    public void uploadContent() {
        if(!check()) return;
        this.getComponent().setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        /* bloquear los controles... */
        publishByFilter.setEnabled(false);
        Thread t = new Thread( new Runnable(){
            public void run(){
                Calendar c = Calendar.getInstance();
                c.add(Calendar.HOUR_OF_DAY, -1);
                try{
                    Filter f = FilterEngine.getFilter(web_url.getText());
                    URL u = new URL(web_url.getText());
                    URLConnection con = u.openConnection();
                    BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
                    String decodedString, html = "";
                    while ((decodedString = in.readLine()) != null) {
                        html += decodedString;
                    }
                    Info i = FilterEngine.getInfo(html, f);

                    String t = i.getTitulo();
                    String autor = i.getAutor();
                    String imagen = web_alt_image.getText().equals("") ? i.getImagen() : web_alt_image.getText();
                    String contenido = i.getContenido();
                    int br_i = contenido.indexOf("<br>");
                    if(br_i != -1){
                        contenido = contenido.substring(0,br_i + "<br>".length()) + "<hr id=\"system-readmore\" />" + contenido.substring(br_i + "<br>".length());
                    }else{
                        br_i = contenido.indexOf("</p>");
                        if(br_i != -1){
                           contenido = contenido.substring(0,br_i + "</p>".length()) + "<hr id=\"system-readmore\" />" + contenido.substring(br_i + "</p>".length());
                        }
                    }

                    in.close();

                    Joomla j = new Joomla(urlJoomla.getText(), userJoomla.getText(), String.valueOf(passJoomla.getPassword()));
                    String nombre = "";

                    if(imagen.startsWith("http")){
                        nombre = imagen.substring(imagen.lastIndexOf("/") + 1, imagen.length());
                    }else
                        nombre = imagen.substring(imagen.lastIndexOf("\\") + 1, imagen.length());
                    try {
                        nombre = URLDecoder.decode(nombre, "UTF-8");
                        nombre = nombre.replace("ñ", "n");
                        nombre = nombre.replace("Ñ", "N");
                    } catch (UnsupportedEncodingException ex) {
                        ex.printStackTrace();
                    }
                    File imageFile = ImageEngine.get(imagen, "imagenes/" + nombre);
                    if(imageFile != null){
                        /* Redimensionar la imagen */
                        BufferedImage img = ImageIO.read(imageFile);
                        if(img.getWidth() > 400)
                            ImageEngine.resize("imagenes/" + nombre,"imagenes/" + nombre, 400);
                        /* Sube imagen por ftp */
                        String host = j.getHost();
                        char[] tmp = passFTP.getPassword();
                        String pass = String.valueOf(tmp);
                        FTPEngine.uploadFile(imageFile, host, userFTP.getText(), pass, dirBaseFTP.getText());
                        Calendar d = Calendar.getInstance();
                        String imgfolder = d.get(Calendar.DAY_OF_MONTH) + "-" + (d.get(Calendar.MONTH)+1) + "-" + d.get(Calendar.YEAR);
                        imagen = "<img src=\"" + dirBaseFTP.getText()+ imgfolder + "/" + imageFile.getName()+ "\" class='caption' align='left' />";
                    }else
                        imagen = "";

                    /* Publicar contenido */
                    String date = c.get(Calendar.YEAR)+ "-" + (c.get(Calendar.MONTH)+1) + "-"+ c.get(Calendar.DAY_OF_MONTH) + " " + c.get(Calendar.HOUR_OF_DAY) + ":" + c.get(Calendar.MINUTE) + ":" + c.get(Calendar.SECOND);
                    boolean isNP = web_np.isSelected() ? true : false;
                    boolean isFP = web_fp.isSelected()? true: false;
                    boolean isNoImage = web_sin_imagen.isSelected() ? true : false;

                    int cid = -1;
                    if(!web_cid.getText().equals(""))
                        cid = Integer.parseInt(web_cid.getText());
                    int sid = -1;
                    if(!web_sid.getText().equals(""))
                        sid = Integer.parseInt(web_sid.getText());

                    j.login();
                    j.insertContent(t, autor, imagen, contenido, date, cid, sid, isNP, isNoImage, isFP, true);
                    j.logout();
                    updateCountThread(-1);
                }catch(MalformedURLException murl){
                    murl.printStackTrace();
                }catch(IOException ioe){
                    ioe.printStackTrace();
                }
            }
        });
        t.start();
        updateCountThread(1);
        
        this.getComponent().setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        /* Desbloquear control */
        publishByFilter.setEnabled(true);
    }

    public void updateCountThread(int i){
        countThread2 += i;
        countHilosLbl.setText("hilos(" + countThread2 + ")");
    }
    
    public void updateCountThread2(int i){
        countThread += i;
        countHilosEditor.setText("hilos(" + countThread + ")");
    }

    @Action
    public void limpiarForm() {
        web_url.setText("");
        web_alt_image.setText("");
        web_cid.setText("");
        web_sid.setText("");
        web_fp.setSelected(false);
        web_np.setSelected(false);
        web_sin_imagen.setSelected(false);
    }

    @Action
    public void openBrowserDialog() {
        JFileChooser fc = new JFileChooser();
        int returnVal = fc.showOpenDialog(this.getComponent());
        if(returnVal == JFileChooser.APPROVE_OPTION){
            art_imagen.setText(fc.getSelectedFile().toString());
        }
    }

    private boolean check(){
        if(this.urlJoomla.getText().equals("") || userJoomla.getText().equals("") || passJoomla.getPassword().toString().equals("") || userFTP.getText().equals("") || passFTP.getPassword().toString().equals("") ){
            JOptionPane.showMessageDialog(jTabbedPane1, "Las credenciales de usuario NO han sido introducidas");
            jTabbedPane1.setSelectedIndex(0);
            return false;
        }
        return true;
    }

    @Action
    public void uploadContent2() {

        if(!check()) return;

        this.getComponent().setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

        /* Bloquear los controles... */
        publishByEditor.setEnabled(false);

        Thread t = new Thread(new Runnable(){
            public void run(){
                String t="",autor="",contenido="",imagen="";
                Calendar c = Calendar.getInstance();
                c.add(Calendar.HOUR_OF_DAY, -1);
                
                if(!art_title.getText().equals("")){
                    t = art_title.getText().trim();
                }
                if(!art_autor.getText().equals("")){
                    autor = art_autor.getText().trim();
                }
                if(!art_texto.getText().equals("")){
                    String txt = art_texto.getText();
                    txt = txt.replaceAll("\r", "");
                    txt = txt.replaceAll("\n", "<br />");
                    txt = txt.replaceAll("<hr/>", "<hr id=\"system-readmore\" />");
                    contenido = txt;
                    /*try{
                        contenido = URLEncoder.encode(txt,"UTF-8");
                    } catch (UnsupportedEncodingException uee) {
                        uee.printStackTrace();
                    }*/
                }
                if(!art_imagen.getText().equals("")){
                    imagen = art_imagen.getText();
                }

                Joomla j = new Joomla(urlJoomla.getText(), userJoomla.getText(), String.valueOf(passJoomla.getPassword()));
                String nombre = "";
                
                if(imagen.startsWith("http")){
                    nombre = imagen.substring(imagen.lastIndexOf("/") + 1, imagen.length());
                }else
                    nombre = imagen.substring(imagen.lastIndexOf("\\") + 1, imagen.length());
                
                try {
                    nombre = URLDecoder.decode(nombre, "UTF-8");
                } catch (UnsupportedEncodingException ex) {
                    ex.printStackTrace();
                }
                File f = ImageEngine.get(imagen, "imagenes/" + nombre);
                if( f == null ){
                    System.out.println("No hay imagen...");
                    imagen = "";
                }else{
                    /* Redimensionar la imagen */
                    try{
                        BufferedImage img = ImageIO.read(f);
                        if(img.getWidth() > 400)
                            ImageEngine.resize("imagenes/" + nombre,"imagenes/" + nombre, 400);
                    }catch(IOException ioe){
                        ioe.printStackTrace();
                    }
                    System.out.println("Se sube: " + f.getName());
                    /* Sube imagen por ftp */
                    String host = j.getHost();
                    char[] tmp = passFTP.getPassword();
                    String pass = String.valueOf(tmp);
                    FTPEngine.uploadFile(f, host, userFTP.getText(), pass, dirBaseFTP.getText());
                    Calendar d = Calendar.getInstance();
                    String imgfolder = d.get(Calendar.DAY_OF_MONTH) + "-" + (d.get(Calendar.MONTH)+1) + "-" + d.get(Calendar.YEAR);
                    imagen = "<img src=\"" + dirBaseFTP.getText()+ imgfolder + "/" + f.getName()+ "\" class='caption' align='left' />";
                }

                /* Publicar contenido */
                String date = c.get(Calendar.YEAR)+ "-" + (c.get(Calendar.MONTH)+1) + "-"+ c.get(Calendar.DAY_OF_MONTH) + c.get(Calendar.HOUR_OF_DAY) + ":" +  c.get(Calendar.MINUTE) + ":" + c.get(Calendar.SECOND);
                
                boolean isFP = art_fp.isSelected() ? true : false;
                boolean isNoImage = art_noimagen.isSelected() ? true : false;
                boolean isNP = art_np.isSelected() ? true : false;

                int cid = -1;
                if(!art_cid.getText().equals(""))
                    cid = Integer.parseInt(art_cid.getText());

                int sid = -1;
                if(!art_sid.getText().equals(""))
                    sid = Integer.parseInt(art_sid.getText());

                j.login();
                j.insertContent(t, autor, imagen, contenido, date, cid, sid, isNP, isNoImage, isFP, true);
                j.logout();
                updateCountThread2(-1);
            }
        });
        t.start();
        updateCountThread2(1);
        this.getComponent().setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        /* Desbloquear control */
        publishByEditor.setEnabled(true);
    }

    @Action
    public void cleanFields() {
        art_title.setText("");
        art_autor.setText("");
        art_imagen.setText("");
        art_texto.setText("");
        art_cid.setText("");
        art_sid.setText("");
        art_fp.setSelected(false);
        art_np.setSelected(false);
        art_noimagen.setSelected(false);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField art_autor;
    private javax.swing.JTextField art_cid;
    private javax.swing.JCheckBox art_fp;
    private javax.swing.JTextField art_imagen;
    private javax.swing.JCheckBox art_noimagen;
    private javax.swing.JCheckBox art_np;
    private javax.swing.JTextField art_sid;
    private javax.swing.JTextArea art_texto;
    private javax.swing.JTextField art_title;
    private javax.swing.JButton clearCredentials;
    private javax.swing.JLabel countHilosEditor;
    private javax.swing.JLabel countHilosLbl;
    private javax.swing.JTextField dirBaseFTP;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton limpiarbtn;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JPasswordField passFTP;
    private javax.swing.JPasswordField passJoomla;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JButton publishByEditor;
    private javax.swing.JButton publishByFilter;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    private javax.swing.JTextField urlJoomla;
    private javax.swing.JTextField userFTP;
    private javax.swing.JTextField userJoomla;
    private javax.swing.JTextField web_alt_image;
    private javax.swing.JTextField web_cid;
    private javax.swing.JCheckBox web_fp;
    private javax.swing.JCheckBox web_np;
    private javax.swing.JTextField web_sid;
    private javax.swing.JCheckBox web_sin_imagen;
    private javax.swing.JTextField web_url;
    // End of variables declaration//GEN-END:variables

    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;

    private JDialog aboutBox;

}
