/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package uploadartgui.filtros;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.*;
import java.net.*;
import java.io.*;
import org.xml.sax.SAXException;
import javax.xml.parsers.ParserConfigurationException;

/**
 *
 * @author soporte
 */
public class FilterEngine {

    private FilterEngine(){}

	public static Filter getFilter(String url){
		Document doc = getDocument(new File("filters.xml"));
		NodeList lista = doc.getElementsByTagName("filter");
		Filter f;
		for(int i = 0 ; i < lista.getLength(); i++){
			Node filtro = lista.item(i);
			if(filtro.getNodeType() == Node.ELEMENT_NODE){
				Element e = (Element) filtro;
				if(url.contains(e.getAttribute("url"))){
					f = new Filter(e.getAttribute("url"));
					/* Buscar los valores de cada filtro */
					NodeList keys = e.getElementsByTagName("key");
					String tmp_t = null, tmp_a = null, tmp_i = null, tmp_c = null;

					for(int j = 0; j < keys.getLength(); j++){
						Node key = keys.item(j);
						if(key.getNodeType() == Node.ELEMENT_NODE){
							Element k = (Element)key;
                                                        k.getAttribute("alt");

							f.setKey(k.getAttribute("name"), k.getAttribute("init"), k.getAttribute("step"), k.getAttribute("end"), k.getAttribute("alt"));
						}
					}
					/* Muestra los valores almacenados desde el filtro */
					System.out.println(f);
					return f;
				}
			}
		}
		return null;
	}

	public static Info getInfo(String page, Filter filtro){
                String imagen, autor, titulo, contenido="";
		/* Buscamos el titulo */
		String inittag = filtro.get(Filter.TITULO).init;
		String endtag = filtro.get(Filter.TITULO).end;
		int endpos, initpos = page.indexOf(inittag);
                if(initpos != -1){
                    initpos += inittag.length();
                    endpos = page.indexOf(endtag, initpos);
                    titulo = page.substring(initpos, endpos);
                    System.out.println("Titulo: " + titulo);
                }else{
                    titulo = "";
                }
                
		/* Buscamos el autor */
                if(!(filtro.get(Filter.AUTOR).alt.equals(""))){
                    autor = filtro.get(Filter.AUTOR).alt;
                }else{
                    inittag = filtro.get(Filter.AUTOR).init;
                    endtag = filtro.get(Filter.AUTOR).end;
                    initpos = page.indexOf(inittag);
                    if(initpos != -1){
                        initpos += inittag.length();
                        endpos = page.indexOf(endtag, initpos);
                        autor = page.substring(initpos, endpos);
                        System.out.println(autor);
                    }else{
                        autor = "";
                    }
                }

                /* Buscamos imagen */
                inittag = filtro.get(Filter.IMAGEN).init;
		endtag = filtro.get(Filter.IMAGEN).end;
		initpos = page.indexOf(inittag);
                if(initpos != -1){
                    initpos += inittag.length();
                    endpos = page.indexOf(endtag, initpos);
                    imagen = page.substring(initpos, endpos);
                    String srcattr_init = "src=\"";
                    String srcattr_end = "\"";
                    int srcpos = imagen.indexOf(srcattr_init);
                    if(srcpos != -1){
                        srcpos += srcattr_init.length();
                        int srcpos_end = imagen.indexOf(srcattr_end, srcpos);
                        imagen = imagen.substring(srcpos, srcpos_end);
                        if(! imagen.contains(filtro.getURL())){
                            imagen = "http://" + filtro.getURL() + "/" + imagen;
                        }
                        System.out.println(imagen);
                    }else{
                        srcattr_init = "src='";
                        srcattr_end = "'";
                        srcpos = imagen.indexOf(srcattr_init);
                        if(srcpos != -1){
                            srcpos += srcattr_init.length();
                            int srcpos_end = imagen.indexOf(srcattr_end, srcpos);
                            imagen = imagen.substring(srcpos, srcpos_end);
                            if(! imagen.contains(filtro.getURL())){
                                imagen += "http://" + filtro.getURL() + "/" + imagen;
                            }
                            System.out.println(imagen);
                        }else
                            imagen = "";
                    }
                }else
                    imagen = "";

                /* Buscamos contenido */
                inittag = filtro.get(Filter.CONTENIDO).init;
		endtag = filtro.get(Filter.CONTENIDO).end;
		initpos = page.indexOf(inittag);
                if(initpos != -1){
                    initpos += inittag.length();
                    endpos = page.indexOf(endtag, initpos);
                    contenido = page.substring(initpos, endpos).trim();
                    System.out.println(contenido);
                }else
                    contenido = "";
                
		return new Info(titulo, autor, imagen, contenido);
	}

	private static Document getDocument(File f){
		Document doc = null;
		try{
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			doc = docBuilder.parse(f);
			doc.normalize();
		}catch(ParserConfigurationException pce){
			pce.printStackTrace();
		}catch(SAXException sax){
			sax.printStackTrace();
		}catch(IOException ioe){
			ioe.printStackTrace();
		}
		return doc;
	}

	public static void main(String[] args){
            try{
		Filter f = FilterEngine.getFilter("http://www.milenio.com/cdb/doc/noticias2011/8307bab64de193d267926089f2d2d489");
		URL u = new URL("http://www.milenio.com/cdb/doc/noticias2011/8307bab64de193d267926089f2d2d489");
                // 307665 y 307715
                // http://www.milenio.com/cdb/doc/noticias2011/8307bab64de193d267926089f2d2d489
                // http://www.proceso.com.mx/?p=307665
		URLConnection con = u.openConnection();
		BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
		String decodedString, html = "";
		while ((decodedString = in.readLine()) != null) {
                    html += decodedString;
		}
                Info i = getInfo(html, f);
		in.close();
            }catch(MalformedURLException murl){
                murl.printStackTrace();
            }catch(IOException ioe){
                ioe.printStackTrace();
            }
	}
    
}