/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package uploadartgui.utilidades;

import java.awt.AlphaComposite;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import javax.imageio.ImageIO;
/**
 *
 * @author Mussio Jair Cárdenas Palomo
 */
public class ImageEngine {

    private ImageEngine(){

    }

    public static void main(String[] arg){
        //get("http://external.ak.fbcdn.net/safe_image.php?d=AQDBHC_JBW1SvGJJ&url=http%3A%2F%2Fi1.ytimg.com%2Fvi%2FLtjHUp0HWFo%2Fhqdefault.jpg","c:\\here.jpg");
        File f = get("http://latinfashionews.com/wp-content/uploads/2011/01/ibero.1.jpg","c:\\here3.jpg");
        System.out.println("Nombre de la nueva imagen: " + f.getName());

        File f2 = get("C:\\Users\\soporte\\Desktop\\ibero.2.jpg", "c:\\here4.jpg");
        System.out.println("Nombre de la nueva imagen: " + f2.getName());
    }

    public static File get(String imageurl, String localfile){
        try{
            if(imageurl.startsWith("http://")){
                URL url = new URL(imageurl);
                URLConnection img = url.openConnection();
                img.setDoOutput(true);
                img.connect();
                File local = new File(localfile);
                FileOutputStream fileOutput = new FileOutputStream(local);
                InputStream inputStream = img.getInputStream();
                int downloadedSize = 0;

                    byte[] buffer = new byte[1024];
                    int bufferLength = 0;
                    while ((bufferLength = inputStream.read(buffer)) > 0) {
                        fileOutput.write(buffer, 0, bufferLength);
                        downloadedSize += bufferLength;
                    }

                fileOutput.close();
                return local;
            }else{
                /* Si son archivos tomados directamente del filesystem solo se copia el contendo de las imagenes */
                File input = new File(imageurl);
                File output = new File(localfile);
                /* Si no existe el archivo destino lo crea */
                if(!output.exists()) output.createNewFile();
                InputStream in = new FileInputStream(input);
                OutputStream out = new FileOutputStream(output);
                byte[] buf = new byte[1024];
                int len;
                while ((len = in.read(buf)) > 0){
                    out.write(buf, 0, len);
                }
                in.close();
                out.close();
                return new File(localfile);
            }
        }catch(MalformedURLException mue){
            mue.printStackTrace();
        }catch(IOException ioe){
            ioe.printStackTrace();
        }
        return null;
    }

    public static void resize(String orig, String dest, int width){
        try{
            File f = new File(orig);
            BufferedImage originalImage = ImageIO.read(f);
            int type = originalImage.getType() == 0 ? BufferedImage.TYPE_INT_ARGB : originalImage.getType();
            /* calculando el % de redimensión para un ancho de 300 pixeles */
            int newWidth = width;
            float percent = (float)(newWidth * 100 / originalImage.getWidth());
            float newHeight = (float)(percent * originalImage.getHeight() / 100);
            BufferedImage resizedImage = new BufferedImage(newWidth, (int)newHeight, type);
            Graphics2D g = resizedImage.createGraphics();
            g.drawImage(originalImage, 0, 0, newWidth, (int)newHeight, null);
            g.dispose();
            g.setComposite(AlphaComposite.Src);
            g.setRenderingHint(RenderingHints.KEY_INTERPOLATION,RenderingHints.VALUE_INTERPOLATION_BILINEAR);
            g.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_QUALITY);
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
            ImageIO.write(resizedImage, "jpg", new File(dest));
        }catch(IOException ioe){
            ioe.printStackTrace();
        }
    }

}
